;
;      To plot 1D slice for 1D test simulations
;      2006.1.20(the)
;
;  Usage:
;
;  idl> .r dread1
;  idl> .r vonz1D1
;
;
; choice of device
;plot_choice='ps'
plot_choice='x'

iwx=1 & jwy=3

!p.charsize=1.5
!p.charthick=1.5
;!p.thick=1.0
;!p.charsize=1.1
;!p.charthick=1.0
;!p.thick=1.0
chsz=2.0
rx=0.6

;ixon1=100

;izon=0 : z=0.0 rs

;mm1=2

!x.range=[0.0,100.0]

int=1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
case plot_choice of
'x' : begin
window,4,xs=600,ys=550,xpos=400,retain=2
end
'ps' : begin
set_plot,'ps'
device,/inches,xsize=7.5,ysize=8.0,yoffset=1,font_size=8
;device,/landscape
;device,/color,xoffset=0.5,yoffset=26.5,xsize=24,ysize=14,font_size=8
;!p.font=0 & device,/times,/italic
end
endcase

iw=iwx*jwy
dx0=1./iwx
dy0=1./jwy

!p.multi=[0,iwx,jwy]
!y.margin=[4.,5.]
!x.margin=[7.,7.]

;max min of vz


vxmx1=fltarr(mfile+1)

bbav1=fltarr(mfile+1)

b0=sqrt(2.0)
vsq=v1*v1+v2*v2+v3*v3
gf=1./sqrt(1.-vsq)
bsq=b1*b1+b2*b2+b3*b3
te=pp/dd
gam=4.0/3.0
h=1.0+gam*te/(gam-1.0)
roh=dd*h
va=sqrt(bsq/(roh+bsq))

eymx1=fltarr(mfile+1)

for mm=1,mfile do begin

 vxmx2=0.0
 bbav2=0.0
 eymx2=0.0
 
 tnum=0.0


 for i=0, ixmax-1 do begin
  for j=0, iymax-1 do begin 


    if(abs(v1(i,j,mm)) le 1.0 and vxmx2 le abs(v1(i,j,mm))) then begin
      vxmx2=v1(i,j,mm)
    endif

    bbav2=bbav2+0.5*(b1(i,j,mm)^2+b2(i,j,mm)^2+b3(i,j,mm)^2)

    
    if(eymx2 le abs(e3(i,j,mm))) then begin
      eymx2=abs(e3(i,j,mm))
    endif  
      
    tnum=tnum+1.0
  endfor
 endfor 

 vxmx1(mm)=vxmx2

 bbav1(mm)=bbav2/tnum
 
 eymx1(mm)=eymx2
endfor

;
;(1) growth rate
;
;

;ldmyct,clr_index=clr,white=white,black=black
;loadct,5

!y.range=[-0.01,1.0]

plot,ctime,vxmx1(*),title='!8 Vx,max',xtitle='time',xstyle=1,ystyle=1,linestyle=0

;(2) Bsq
!y.range=[0.7,1.0]

plot,ctime,bbav1(*)/bbav1(1),title='!8 magnetic energy',xtitle='time',xstyle=1,ystyle=1,linestyle=0


;(2) Ey/B0

!y.range=[0.0,0.2]


plot,ctime,abs(e3(1020,400,*))/b0,title='!8E!Dz!N/B!D0!N',xtitle='time',xstyle=1,ystyle=1,linestyle=0
oplot,ctime,abs(e3(1020,400,*))/abs(va(1000,460,*)*b1(1000,460,*)),linestyle=2
;oplot,ctime,eymx1(*)/b0,linestyle=2
;oplot,ctime,abs(v2(1040,400,*))/va(1040,400,*),linestyle=1


if (plot_choice ne 'x') then begin
   device,color=0
   device,/close
   !p.font=-1
;   set_plot,'x'
endif


end
