!---------------------------------------------------------------------@
subroutine calflx(uriir,urijr,urikr,uriil,urijl,urikl,&
                 nm0,uuir,uujr,uukr,uuil,uujl,uukl,&
                 wwir,wwjr,wwkr,wwil,wwjl,wwkl, &
                 is1,ie1,js1,je1,ks1,ke1)
!---------------------------------------------------------------------@
!
!     Calculate flux at cell-interface
!
  use pram, only : imax, jmax, kmax, nv, ns, gam, c0, ieos, iflag
  implicit none

  integer :: i, j, k, is1, ie1, js1, je1, ks1, ke1
  integer :: nm0  
!
  real(8) :: uriir(ns,is1:ie1,js1:je1,ks1:ke1), &
             uriil(ns,is1:ie1,js1:je1,ks1:ke1), &
             urijr(ns,is1:ie1,js1:je1,ks1:ke1), &
             urijl(ns,is1:ie1,js1:je1,ks1:ke1), &
             urikr(ns,is1:ie1,js1:je1,ks1:ke1), &
             urikl(ns,is1:ie1,js1:je1,ks1:ke1)
!
  real(8) :: uuir(nv,is1:ie1,js1:je1,ks1:ke1), &
             uuil(nv,is1:ie1,js1:je1,ks1:ke1), &
             uujr(nv,is1:ie1,js1:je1,ks1:ke1), &
             uujl(nv,is1:ie1,js1:je1,ks1:ke1), &
             uukr(nv,is1:ie1,js1:je1,ks1:ke1), &
             uukl(nv,is1:ie1,js1:je1,ks1:ke1)
!
  real(8) :: wwir(nv,is1:ie1,js1:je1,ks1:ke1), &
             wwil(nv,is1:ie1,js1:je1,ks1:ke1), &
             wwjr(nv,is1:ie1,js1:je1,ks1:ke1), &
             wwjl(nv,is1:ie1,js1:je1,ks1:ke1), &
             wwkr(nv,is1:ie1,js1:je1,ks1:ke1), &
             wwkl(nv,is1:ie1,js1:je1,ks1:ke1)
!
  real(8) :: roir, rojr, rokr, roil, rojl, rokl
  real(8) :: vxir, vxjr, vxkr, vxil, vxjl, vxkl
  real(8) :: vyir, vyjr, vykr, vyil, vyjl, vykl
  real(8) :: vzir, vzjr, vzkr, vzil, vzjl, vzkl 
  real(8) :: ppir, ppjr, ppkr, ppil, ppjl, ppkl
  real(8) :: bxir, bxjr, bxkr, bxil, bxjl, bxkl 
  real(8) :: byir, byjr, bykr, byil, byjl, bykl 
  real(8) :: bzir, bzjr, bzkr, bzil, bzjl, bzkl
  real(8) :: exir, exjr, exkr, exil, exjl, exkl 
  real(8) :: eyir, eyjr, eykr, eyil, eyjl, eykl 
  real(8) :: ezir, ezjr, ezkr, ezil, ezjl, ezkl
  real(8) :: chir, chjr, chkr, chil, chjl, chkl
  real(8) :: phir, phjr, phkr, phil, phjl, phkl
  real(8) :: psir, psjr, pskr, psil, psjl, pskl
  real(8) :: sgir, sgjr, sgkr, sgil, sgjl, sgkl
  real(8) :: vtir, vtjr, vtkr, vtil, vtjl, vtkl 
  real(8) :: btir, btjr, btkr, btil, btjl, btkl
  real(8) :: etir, etjr, etkr, etil, etjl, etkl
  real(8) :: evir, evjr, evkr, evil, evjl, evkl 
  real(8) :: gfir, gfjr, gfkr, gfil, gfjl, gfkl
  real(8) :: droir, drojr, drokr, droil, drojl, drokl 
  real(8) :: sxir, sxjr, sxkr, sxil, sxjl, sxkl 
  real(8) :: syir, syjr, sykr, syil, syjl, sykl 
  real(8) :: szir, szjr, szkr, szil, szjl, szkl 
  real(8) :: eemir, eemjr, eemkr, eemil, eemjl, eemkl
  real(8) :: rohir, rohjr, rohkr, rohil, rohjl, rohkl 
  real(8) :: roeir, roejr, roekr, roeil, roejl, roekl 
  real(8) :: denrir, denrjr, denrkr, denril, denrjl, denrkl
  real(8) :: eeir, eejr, eekr, eeil, eejl, eekl  
  real(8) :: ron
!
!----------------------------------------------------------------------
  ron=1.d0

  do k=ks1+nm0-1,ke1-nm0
    do j=js1+nm0-1,je1-nm0
      do i=is1+nm0-1,ie1-nm0

        roir=uriir(1,i,j,k)
        rojr=urijr(1,i,j,k)
        rokr=urikr(1,i,j,k)
        roil=uriil(1,i,j,k)
        rojl=urijl(1,i,j,k)
        rokl=urikl(1,i,j,k)
         
        vxir=uriir(2,i,j,k)
        vxjr=urijr(2,i,j,k)
        vxkr=urikr(2,i,j,k)
        vxil=uriil(2,i,j,k)
        vxjl=urijl(2,i,j,k)
        vxkl=urikl(2,i,j,k)
         
        vyir=uriir(3,i,j,k)
        vyjr=urijr(3,i,j,k)
        vykr=urikr(3,i,j,k)
        vyil=uriil(3,i,j,k)
        vyjl=urijl(3,i,j,k)
        vykl=urikl(3,i,j,k)
         
        vzir=uriir(4,i,j,k)
        vzjr=urijr(4,i,j,k)
        vzkr=urikr(4,i,j,k)
        vzil=uriil(4,i,j,k)
        vzjl=urijl(4,i,j,k)
        vzkl=urikl(4,i,j,k)
        
        ppir=uriir(5,i,j,k)
        ppjr=urijr(5,i,j,k)
        ppkr=urikr(5,i,j,k)
        ppil=uriil(5,i,j,k)
        ppjl=urijl(5,i,j,k)
        ppkl=urikl(5,i,j,k)
        
        bxir=uriir(7,i,j,k)
        bxjr=urijr(7,i,j,k)
        bxkr=urikr(7,i,j,k)
        bxil=uriil(7,i,j,k)
        bxjl=urijl(7,i,j,k)
        bxkl=urikl(7,i,j,k)
        
        byir=uriir(8,i,j,k)
        byjr=urijr(8,i,j,k)
        bykr=urikr(8,i,j,k)
        byil=uriil(8,i,j,k)
        byjl=urijl(8,i,j,k)
        bykl=urikl(8,i,j,k)
        
        bzir=uriir(9,i,j,k)
        bzjr=urijr(9,i,j,k)
        bzkr=urikr(9,i,j,k)
        bzil=uriil(9,i,j,k)
        bzjl=urijl(9,i,j,k)
        bzkl=urikl(9,i,j,k)
! RRMHD
        exir=uriir(10,i,j,k)
        exjr=urijr(10,i,j,k)
        exkr=urikr(10,i,j,k)
        exil=uriir(10,i,j,k)
        exjl=urijr(10,i,j,k)
        exkl=urikr(10,i,j,k)

        eyir=uriir(11,i,j,k)
        eyjr=urijr(11,i,j,k)
        eykr=urikr(11,i,j,k)
        eyil=uriir(11,i,j,k)
        eyjl=urijr(11,i,j,k)
        eykl=urikr(11,i,j,k)

        ezir=uriir(12,i,j,k)
        ezjr=urijr(12,i,j,k)
        ezkr=urikr(12,i,j,k)
        ezil=uriir(12,i,j,k)
        ezjl=urijr(12,i,j,k)
        ezkl=urikr(12,i,j,k)

        chir=uriir(13,i,j,k)
        chjr=urijr(13,i,j,k)
        chkr=urikr(13,i,j,k)
        chil=uriir(13,i,j,k)
        chjl=urijr(13,i,j,k)
        chkl=urikr(13,i,j,k)

        phir=uriir(14,i,j,k)
        phjr=urijr(14,i,j,k)
        phkr=urikr(14,i,j,k)
        phil=uriir(14,i,j,k)
        phjl=urijr(14,i,j,k)
        phkl=urikr(14,i,j,k)

        psir=uriir(15,i,j,k)
        psjr=urijr(15,i,j,k)
        pskr=urikr(15,i,j,k)
        psil=uriil(15,i,j,k)
        psjl=urijl(15,i,j,k)
        pskl=urikl(15,i,j,k)

        sgir=uriir(16,i,j,k)
        sgjr=urijr(16,i,j,k)
        sgkr=urikr(16,i,j,k)
        sgil=uriil(16,i,j,k)
        sgjl=urijl(16,i,j,k)
        sgkl=urikl(16,i,j,k)

! RRMHD         
        vtir=vxir*vxir+vyir*vyir+vzir*vzir
        vtjr=vxjr*vxjr+vyjr*vyjr+vzjr*vzjr
        vtkr=vxkr*vxkr+vykr*vykr+vzkr*vzkr
        vtil=vxil*vxil+vyil*vyil+vzil*vzil
        vtjl=vxjl*vxjl+vyjl*vyjl+vzjl*vzjl
        vtkl=vxkl*vxkl+vykl*vykl+vzkl*vzkl
         
        btir=bxir**2+byir**2+bzir**2
        btjr=bxjr**2+byjr**2+bzjr**2
        btkr=bxkr**2+bykr**2+bzkr**2
        btil=bxil**2+byil**2+bzil**2
        btjl=bxjl**2+byjl**2+bzjl**2
        btkl=bxkl**2+bykl**2+bzkl**2

        etir=exir**2+eyir**2+ezir**2
        etjr=exjr**2+eyjr**2+ezjr**2
        etkr=exkr**2+eykr**2+ezkr**2
        etil=exil**2+eyil**2+ezil**2
        etjl=exjl**2+eyjl**2+ezjl**2
        etkl=exkl**2+eykl**2+ezkl**2
 
        evir=exir*vxir+eyir*vyir+ezir*vzir
        evjr=exjr*vxjr+eyjr*vyjr+ezjr*vzjr
        evkr=exkr*vxkr+eykr*vykr+ezkr*vzkr
        evil=exil*vxil+eyil*vyil+ezil*vzil
        evjl=exjl*vxjl+eyjl*vyjl+ezjl*vzjl
        evkl=exkl*vxkl+eykl*vykl+ezkl*vzkl
    
        gfir=1.0/sqrt(1.0-vtir/c0**2)
        gfjr=1.0/sqrt(1.0-vtjr/c0**2)
        gfkr=1.0/sqrt(1.0-vtkr/c0**2)
        gfil=1.0/sqrt(1.0-vtil/c0**2)
        gfjl=1.0/sqrt(1.0-vtjl/c0**2)
        gfkl=1.0/sqrt(1.0-vtkl/c0**2)
        
        droir=roir*gfir
        drojr=rojr*gfjr
        drokr=rokr*gfkr
        droil=roil*gfil
        drojl=rojl*gfjl
        drokl=rokl*gfkl
        
        sxir=(eyir*bzir-ezir*byir)/c0
        sxjr=(eyjr*bzjr-ezjr*byjr)/c0
        sxkr=(eykr*bzkr-ezkr*bykr)/c0
        sxil=(eyil*bzil-ezil*byil)/c0
        sxjl=(eyjl*bzjl-ezjl*byjl)/c0
        sxkl=(eykl*bzkl-ezkl*bykl)/c0
       
        syir=(ezir*bxir-exir*bzir)/c0
        syjr=(ezjr*bxjr-exjr*bzjr)/c0
        sykr=(ezkr*bxkr-exkr*bzkr)/c0
        syil=(ezil*bxil-exil*bzil)/c0
        syjl=(ezjl*bxjl-exjl*bzjl)/c0
        sykl=(ezkl*bxkl-exkl*bzkl)/c0
       
        szir=(exir*byir-eyir*bxir)/c0
        szjr=(exjr*byjr-eyjr*bxjr)/c0
        szkr=(exkr*bykr-eykr*bxkr)/c0
        szil=(exil*byil-eyil*bxil)/c0
        szjl=(exjl*byjl-eyjl*bxjl)/c0
        szkl=(exkl*bykl-eykl*bxkl)/c0
         
        eemir=0.5*(btir+etir)
        eemjr=0.5*(btjr+etjr)
        eemkr=0.5*(btkr+etkr)
        eemil=0.5*(btil+etil)
        eemjl=0.5*(btjl+etjl)
        eemkl=0.5*(btkl+etkl)

        if(ieos .eq. 0) then
          rohir=roir+(gam/(gam-1.0))*ppir
          rohjr=rojr+(gam/(gam-1.0))*ppjr
          rohkr=rokr+(gam/(gam-1.0))*ppkr
          rohil=roil+(gam/(gam-1.0))*ppil
          rohjl=rojl+(gam/(gam-1.0))*ppjl
          rohkl=rokl+(gam/(gam-1.0))*ppkl
        elseif(ieos .eq. 1) then
          rohir=(5./2.)*ppir+sqrt((9./4.)*ppir**2 +roir**2)
          rohjr=(5./2.)*ppjr+sqrt((9./4.)*ppjr**2 +rojr**2)
          rohkr=(5./2.)*ppkr+sqrt((9./4.)*ppkr**2 +rokr**2)
          rohil=(5./2.)*ppil+sqrt((9./4.)*ppil**2 +roil**2)
          rohjl=(5./2.)*ppjl+sqrt((9./4.)*ppjl**2 +rojl**2)
          rohkl=(5./2.)*ppkl+sqrt((9./4.)*ppkl**2 +rokl**2)
        elseif(ieos .eq. 2) then
          roeir=(3./2.)*(ppir+((3.*ppir**2)&
              /(2.0*roir+sqrt(2.*ppir**2+4.*roir**2)) ))
          roejr=(3./2.)*(ppjr+((3.*ppjr**2)&
              /(2.0*rojr+sqrt(2.*ppjr**2+4.*rojr**2)) ))
          roekr=(3./2.)*(ppkr+((3.*ppkr**2)&
              /(2.0*rokr+sqrt(2.*ppkr**2+4.*rokr**2)) ))
          roeil=(3./2.)*(ppil+((3.*ppil**2)&
              /(2.0*roil+sqrt(2.*ppil**2+4.*roil**2)) ))
          roejl=(3./2.)*(ppjl+((3.*ppjl**2)&
              /(2.0*rojl+sqrt(2.*ppjl**2+4.*rojl**2)) ))
          roekl=(3./2.)*(ppkl+((3.*ppkl**2)&
              /(2.0*rokl+sqrt(2.*ppkl**2+4.*rokl**2)) ))
          rohir=roir+roeir+ppir
          rohjr=rojr+roejr+ppjr
          rohkr=rokr+roekr+ppkr
          rohil=roil+roeil+ppil
          rohjl=rojl+roejl+ppjl
          rohkl=rokl+roekl+ppkl
        elseif(ieos .eq. 3) then
          rohir=(12.*ppir**2+8.*ppir*roir+2.*roir**2)/(3.*ppir+2.*roir)
          rohjr=(12.*ppjr**2+8.*ppjr*rojr+2.*rojr**2)/(3.*ppjr+2.*rojr)
          rohkr=(12.*ppkr**2+8.*ppkr*rokr+2.*rokr**2)/(3.*ppkr+2.*rokr)
          rohil=(12.*ppil**2+8.*ppil*roil+2.*roil**2)/(3.*ppil+2.*roil)
          rohjl=(12.*ppjl**2+8.*ppjl*rojr+2.*rojl**2)/(3.*ppjl+2.*rojl)
          rohkl=(12.*ppkl**2+8.*ppkl*rokr+2.*rokl**2)/(3.*ppkl+2.*rokl)
        endif
        
        denrir=(gfir**2)*rohir
        denrjr=(gfjr**2)*rohjr
        denrkr=(gfkr**2)*rohkr
        denril=(gfil**2)*rohil
        denrjl=(gfjl**2)*rohjl
        denrkl=(gfkl**2)*rohkl
        
        eeir=denrir-ppir+eemir
        eejr=denrjr-ppjr+eemjr
        eekr=denrkr-ppkr+eemkr
        eeil=denril-ppil+eemil
        eejl=denrjl-ppjl+eemjl
        eekl=denrkl-ppkl+eemkl
!
        uuir(1,i,j,k)=droir
        uuir(2,i,j,k)=denrir*vxir+sxir
        uuir(3,i,j,k)=denrir*vyir+syir
        uuir(4,i,j,k)=denrir*vzir+szir
        uuir(5,i,j,k)=eeir
        uuir(7,i,j,k)=bxir
        uuir(8,i,j,k)=byir
        uuir(9,i,j,k)=bzir
        uuir(10,i,j,k)=exir
        uuir(11,i,j,k)=eyir
        uuir(12,i,j,k)=ezir
        uuir(13,i,j,k)=chir
        uuir(14,i,j,k)=phir
        uuir(15,i,j,k)=psir
!
        uujr(1,i,j,k)=drojr
        uujr(2,i,j,k)=denrjr*vxjr+sxjr
        uujr(3,i,j,k)=denrjr*vyjr+syjr
        uujr(4,i,j,k)=denrjr*vzjr+szjr
        uujr(5,i,j,k)=eejr
        uujr(7,i,j,k)=bxjr
        uujr(8,i,j,k)=byjr
        uujr(9,i,j,k)=bzjr
        uujr(10,i,j,k)=exjr
        uujr(11,i,j,k)=eyjr
        uujr(12,i,j,k)=ezjr
        uujr(13,i,j,k)=chjr
        uujr(14,i,j,k)=phjr
        uujr(15,i,j,k)=psjr
!
        uukr(1,i,j,k)=drokr
        uukr(2,i,j,k)=denrkr*vxkr+sxkr
        uukr(3,i,j,k)=denrkr*vykr+sykr
        uukr(4,i,j,k)=denrkr*vzkr+szkr
        uukr(5,i,j,k)=eekr
        uukr(7,i,j,k)=bxkr
        uukr(8,i,j,k)=bykr
        uukr(9,i,j,k)=bzkr
        uukr(10,i,j,k)=exkr
        uukr(11,i,j,k)=eykr
        uukr(12,i,j,k)=ezkr
        uukr(13,i,j,k)=chkr
        uukr(14,i,j,k)=phkr
        uukr(15,i,j,k)=pskr
!
        uuil(1,i,j,k)=droil
        uuil(2,i,j,k)=denril*vxil+sxil
        uuil(3,i,j,k)=denril*vyil+syil
        uuil(4,i,j,k)=denril*vzil+szil
        uuil(5,i,j,k)=eeil
        uuil(7,i,j,k)=bxil
        uuil(8,i,j,k)=byil
        uuil(9,i,j,k)=bzil
        uuil(10,i,j,k)=exil
        uuil(11,i,j,k)=eyil
        uuil(12,i,j,k)=ezil
        uuil(13,i,j,k)=chil
        uuil(14,i,j,k)=phil
        uuil(15,i,j,k)=psil
!
        uujl(1,i,j,k)=drojl
        uujl(2,i,j,k)=denrjl*vxjl+sxjl
        uujl(3,i,j,k)=denrjl*vyjl+syjl
        uujl(4,i,j,k)=denrjl*vzjl+szjl
        uujl(5,i,j,k)=eejl
        uujl(7,i,j,k)=bxjl
        uujl(8,i,j,k)=byjl
        uujl(9,i,j,k)=bzjl
        uujl(10,i,j,k)=exjl
        uujl(11,i,j,k)=eyjl
        uujl(12,i,j,k)=ezjl
        uujl(13,i,j,k)=chjl
        uujl(14,i,j,k)=phjl
        uujl(15,i,j,k)=psjl
!
        uukl(1,i,j,k)=drokl
        uukl(2,i,j,k)=denrkl*vxkl+sxkl
        uukl(3,i,j,k)=denrkl*vykl+sykl
        uukl(4,i,j,k)=denrkl*vzkl+szkl
        uukl(5,i,j,k)=eekl
        uukl(7,i,j,k)=bxkl
        uukl(8,i,j,k)=bykl
        uukl(9,i,j,k)=bzkl
        uukl(10,i,j,k)=exkl
        uukl(11,i,j,k)=eykl
        uukl(12,i,j,k)=ezkl
        uukl(13,i,j,k)=chkl
        uukl(14,i,j,k)=phkl
        uukl(15,i,j,k)=pskl
!
        if( iflag(6).le.1 ) then
          uuir(6,i,j,k)=gfir*roir
          uujr(6,i,j,k)=gfjr*rojr
          uukr(6,i,j,k)=gfkr*rokr
          uuil(6,i,j,k)=gfil*roil
          uujl(6,i,j,k)=gfjl*rojl
          uukl(6,i,j,k)=gfkl*rokl
        elseif( iflag(6).le.3 ) then
          uuir(6,i,j,k)=gfir*ppir/roir**(gam-1.0)
          uujr(6,i,j,k)=gfjr*ppjr/rojr**(gam-1.0)
          uukr(6,i,j,k)=gfkr*ppkr/rokr**(gam-1.0)
          uuil(6,i,j,k)=gfil*ppil/roil**(gam-1.0)
          uujl(6,i,j,k)=gfjl*ppjl/rojl**(gam-1.0)
          uukl(6,i,j,k)=gfkl*ppkl/rokl**(gam-1.0)
        elseif( iflag(6).eq.4 ) then
          uuil(6,i,j,k)=gfir*roir*log(ppir/roir**gam)
          uujl(6,i,j,k)=gfjr*rojr*log(ppjr/rojr**gam)
          uukl(6,i,j,k)=gfkr*rokr*log(ppkr/rokr**gam)
          uuil(6,i,j,k)=gfil*roil*log(ppil/roil**gam)
          uujl(6,i,j,k)=gfjl*rojl*log(ppjl/rojl**gam)
          uukl(6,i,j,k)=gfkl*rokl*log(ppkl/rokl**gam)
        endif
!
! Hydro Part
        wwir(1,i,j,k)=droir*vxir
        wwir(2,i,j,k)=denrir*vxir*vxir+ppir
        wwir(3,i,j,k)=denrir*vxir*vyir
        wwir(4,i,j,k)=denrir*vxir*vzir
        wwir(5,i,j,k)=denrir*vxir
        wwir(6,i,j,k)=uuir(6,i,j,k)*vxir
        
        wwil(1,i,j,k)=droil*vxil
        wwil(2,i,j,k)=denril*vxil*vxil+ppil
        wwil(3,i,j,k)=denril*vxil*vyil
        wwil(4,i,j,k)=denril*vxil*vzil
        wwil(5,i,j,k)=denril*vxil
        wwil(6,i,j,k)=uuil(6,i,j,k)*vxil
        
        wwjr(1,i,j,k)=drojr*vyjr
        wwjr(2,i,j,k)=denrjr*vyjr*vxjr
        wwjr(3,i,j,k)=denrjr*vyjr*vyjr+ppjr
        wwjr(4,i,j,k)=denrjr*vyjr*vzjr
        wwjr(5,i,j,k)=denrjr*vyjr
        wwjr(6,i,j,k)=uujr(6,i,j,k)*vyjr
        
        wwjl(1,i,j,k)=drojl*vyjl
        wwjl(2,i,j,k)=denrjl*vyjl*vxjl
        wwjl(3,i,j,k)=denrjl*vyjl*vyjl+ppjl
        wwjl(4,i,j,k)=denrjl*vyjl*vzjl
        wwjl(5,i,j,k)=denrjl*vyjl
        wwjl(6,i,j,k)=uujl(6,i,j,k)*vyjl
         
        wwkr(1,i,j,k)=drokr*vzkr
        wwkr(2,i,j,k)=denrkr*vzkr*vxkr
        wwkr(3,i,j,k)=denrkr*vzkr*vykr
        wwkr(4,i,j,k)=denrkr*vzkr*vzkr+ppkr
        wwkr(5,i,j,k)=denrkr*vzkr
        wwkr(6,i,j,k)=uukr(6,i,j,k)*vzkr

        wwkl(1,i,j,k)=drokl*vzkl
        wwkl(2,i,j,k)=denrkl*vzkl*vxkl
        wwkl(3,i,j,k)=denrkl*vzkl*vykl
        wwkl(4,i,j,k)=denrkl*vzkl*vzkl+ppkl
        wwkl(5,i,j,k)=denrkl*vzkl
        wwkl(6,i,j,k)=uukl(6,i,j,k)*vzkl
!
! EM part
        wwir(2,i,j,k)=wwir(2,i,j,k)-bxir*bxir-exir*exir+eemir
        wwir(3,i,j,k)=wwir(3,i,j,k)-bxir*byir-exir*eyir
        wwir(4,i,j,k)=wwir(4,i,j,k)-bxir*bzir-exir*ezir
        wwir(5,i,j,k)=wwir(5,i,j,k)+sxir
        wwir(7,i,j,k)=phir
        wwir(8,i,j,k)=-ezir
        wwir(9,i,j,k)=eyir
        wwir(10,i,j,k)=psir
        wwir(11,i,j,k)=bzir
        wwir(12,i,j,k)=-byir
        wwir(13,i,j,k)=sgir*gfir*(exir+(vyir*bzir-vzir*byir)-evir*vxir) &
                       +chir*vxir
        wwir(14,i,j,k)=bxir
        wwir(15,i,j,k)=exir

        wwil(2,i,j,k)=wwil(2,i,j,k)-bxil*bxil-exil*exil+eemil
        wwil(3,i,j,k)=wwil(3,i,j,k)-bxil*byil-exil*eyil
        wwil(4,i,j,k)=wwil(4,i,j,k)-bxil*bzil-exil*ezil
        wwil(5,i,j,k)=wwil(5,i,j,k)+sxil
        wwil(7,i,j,k)=phil
        wwil(8,i,j,k)=-ezil
        wwil(9,i,j,k)=eyil
        wwil(10,i,j,k)=psil
        wwil(11,i,j,k)=bzil
        wwil(12,i,j,k)=-byil
        wwil(13,i,j,k)=sgil*gfil*(exil+(vyil*bzil-vzil*byil)-evil*vxil) &
                       +chil*vxil
        wwir(14,i,j,k)=bxil
        wwir(15,i,j,k)=exil

        wwjr(2,i,j,k)=wwjr(2,i,j,k)-byjr*bxjr-eyjr*exjr
        wwjr(3,i,j,k)=wwjr(3,i,j,k)-byjr*byjr-eyjr*eyjr+eemjr
        wwjr(4,i,j,k)=wwjr(4,i,j,k)-byjr*bzjr-eyjr*ezjr
        wwjr(5,i,j,k)=wwjr(5,i,j,k)+syjr
        wwjr(7,i,j,k)=ezjr
        wwjr(8,i,j,k)=phjr
        wwjr(9,i,j,k)=-exjr
        wwjr(10,i,j,k)=-bzjr
        wwjr(11,i,j,k)=psjr
        wwjr(12,i,j,k)=bxjr
        wwjr(13,i,j,k)=sgjr*gfjr*(eyjr+(vzjr*bxjr-vxjr*bzjr)-evjr*vyjr) &
                       +chjr*vyjr
        wwjr(14,i,j,k)=byjr
        wwjr(15,i,j,k)=eyjr

        wwjl(2,i,j,k)=wwjl(2,i,j,k)-byjl*bxjl-eyjl*exjl
        wwjl(3,i,j,k)=wwjl(3,i,j,k)-byjl*byjl-eyjl*eyjl+eemjl
        wwjl(4,i,j,k)=wwjl(4,i,j,k)-byjl*bzjl-eyjl*ezjl
        wwjl(5,i,j,k)=wwjl(5,i,j,k)+syjl
        wwjl(7,i,j,k)=ezjl
        wwjl(8,i,j,k)=phjl
        wwjl(9,i,j,k)=-exjl
        wwjl(10,i,j,k)=-bzjl
        wwjl(11,i,j,k)=psjl
        wwjl(12,i,j,k)=bxjl
        wwjl(13,i,j,k)=sgjl*gfjl*(eyjl+(vzjl*bxjl-vxjl*bzjl)-evjl*vyjl) &
                       +chjl*vyjl
        wwjl(14,i,j,k)=byjl
        wwjl(15,i,j,k)=eyjl

        wwkr(2,i,j,k)=wwkr(2,i,j,k)-bzkr*bxkr-ezkr*exkr
        wwkr(3,i,j,k)=wwkr(3,i,j,k)-bzkr*bykr-ezkr*eykr
        wwkr(4,i,j,k)=wwkr(4,i,j,k)-bzkr*bzkr-ezkr*ezkr+eemkr
        wwkr(5,i,j,k)=wwkr(5,i,j,k)+szkr
        wwkr(7,i,j,k)=-eykr
        wwkr(8,i,j,k)=exkr
        wwkr(9,i,j,k)=phkr
        wwkr(10,i,j,k)=bykr
        wwkr(11,i,j,k)=-bxkr
        wwkr(12,i,j,k)=pskr
        wwkr(13,i,j,k)=sgkr*gfkr*(ezkr+(vxkr*bykr-vykr*bxkr)-evkr*vzkr) &
                       +chkr*vzkr
        wwkr(14,i,j,k)=bzkr
        wwkr(15,i,j,k)=ezkr

        wwkl(2,i,j,k)=wwkl(2,i,j,k)-bzkl*bxkl-ezkl*exkl
        wwkl(3,i,j,k)=wwkl(3,i,j,k)-bzkl*bykl-ezkl*eykl
        wwkl(4,i,j,k)=wwkl(4,i,j,k)-bzkl*bzkl-ezkl*ezkl+eemkl
        wwkr(5,i,j,k)=wwkl(5,i,j,k)+szkl
        wwkl(7,i,j,k)=-eykl
        wwkl(8,i,j,k)=exkl
        wwkl(9,i,j,k)=phkl
        wwkl(10,i,j,k)=bykl
        wwkl(11,i,j,k)=-bxkl
        wwkl(12,i,j,k)=pskl
        wwkl(13,i,j,k)=sgkl*gfkl*(ezkl+(vxkl*bykl-vykl*bxkl)-evkl*vzkl) &
                       +chkl*vzkl
        wwkl(14,i,j,k)=bzkl
        wwkl(15,i,j,k)=ezkl

      enddo
    enddo
  enddo

  return
end subroutine calflx
!
!---------------------------------------------------------------------@
subroutine calflx3i(uu,wwi,uri,nm0,is1,ie1,js1,je1,ks1,ke1)
!---------------------------------------------------------------------@
  use pram, only : imax, jmax, kmax, nv, ns, gam, c0, ieos  
  implicit none
!
  integer :: i, j, k, is1, ie1, js1, je1, ks1, ke1
  integer :: nm0
  integer :: merr  
!
  real(8) :: uu(nv,is1:ie1,js1:je1,ks1:ke1)
  real(8) :: wwi(nv,is1:ie1,js1:je1,ks1:ke1)
  real(8) :: uri(ns,is1:ie1,js1:je1,ks1:ke1)

  real(8) :: ro, vx, vy, vz, pp, bx, by, bz, ex, ey, ez, ch, ph, ps, sg, &
             dro, ee, vt, bt, et, ev, gf, sx, sy, sz, eem, roh, dp

!=====================================================================@
 
  do k=ks1+nm0-1,ke1-nm0
    do j=js1+nm0-1,je1-nm0
      do i=is1+nm0-1,ie1-nm0
        
!        dro=uu(1,i,j,k)
!        ee=uu(5,i,j,k)
!        bx(i,j,k)=uu(7,i,j,k)
!        by(i,j,k)=uu(8,i,j,k)
!        bz(i,j,k)=uu(9,i,j,k)
        
        ro=uri(1,i,j,k)
        vx=uri(2,i,j,k)
        vy=uri(3,i,j,k)
        vz=uri(4,i,j,k)
        pp=uri(5,i,j,k)
        bx=uri(7,i,j,k)
        by=uri(8,i,j,k)
        bz=uri(9,i,j,k)
        ex=uri(10,i,j,k)
        ey=uri(11,i,j,k)
        ez=uri(12,i,j,k)
        ch=uri(13,i,j,k)
        ph=uri(14,i,j,k)
        ps=uri(15,i,j,k)
        sg=uri(16,i,j,k)
! 
        vt=vx**2+vy**2+vz**2
        gf=1.0/sqrt(1.0-vt/c0**2)
        
        bt=bx**2+by**2+bz**2
        et=ex**2+ey**2+ez**2
        ev=ex*vx+ey*vy+ez*vz

        sx=(ey*bz-ez*by)/c0
        sy=(ez*bx-ex*bz)/c0
        sz=(ex*by-ey*bx)/c0

        eem=0.5*(bt+et)
        dro=gf*ro 
        if(ieos .eq. 0) then
          roh=ro+(gam/(gam-1.0))*pp
        elseif(ieos .eq. 1) then
          roh=(5./2.)*pp+sqrt((9./4.)*pp**2+ro**2)
        elseif(ieos .eq. 3) then
          roh=(12.*pp**2+8.*pp*ro+2.*ro**2)/(3.*pp+2.*ro)
        endif
        dp=(gf**2)*roh
!
        wwi(1,i,j,k)=dro*vx
        wwi(2,i,j,k)=dp*vx*vx+pp-bx*bx-ex*ex+eem
        wwi(3,i,j,k)=dp*vx*vy   -bx*by-ex*ey
        wwi(4,i,j,k)=dp*vx*vz   -bx*bz-ex*ez
        wwi(5,i,j,k)=dp*vx+sx
        wwi(6,i,j,k)=uu(6,i,j,k)*vx
        wwi(7,i,j,k)=ph
        wwi(8,i,j,k)=-ez
        wwi(9,i,j,k)=ey
        wwi(10,i,j,k)=ps
        wwi(11,i,j,k)=bz
        wwi(12,i,j,k)=-by
        wwi(13,i,j,k)=sg*gf*(ex+(vy*bz-vz*by)-ev*vx)+ch*vx
        wwi(14,i,j,k)=bx
        wwi(15,i,j,k)=ex
         
      enddo
    enddo
  enddo

  return
end subroutine calflx3i
!
!---------------------------------------------------------------------@
subroutine calflx3j(uu,wwj,uri,nm0,is1,ie1,js1,je1,ks1,ke1)
!---------------------------------------------------------------------@
  use pram, only : imax, jmax, kmax, nv, ns, gam, c0, ieos  
  implicit none
!
  integer :: i, j, k, is1, ie1, js1, je1, ks1, ke1
  integer :: nm0
  integer :: merr  
!
  real(8) :: uu(nv,is1:ie1,js1:je1,ks1:ke1)
  real(8) :: wwj(nv,is1:ie1,js1:je1,ks1:ke1)
  real(8) :: uri(ns,is1:ie1,js1:je1,ks1:ke1)

  real(8) :: ro, vx, vy, vz, pp, bx, by, bz, ex, ey, ez, ch, ph, ps, sg, &
             dro, ee, vt, bt, et, ev, gf, sx, sy, sz, eem, roh, dp

!=====================================================================@
 
  do k=ks1+nm0-1,ke1-nm0
    do j=js1+nm0-1,je1-nm0
      do i=is1+nm0-1,ie1-nm0
        
!        dro=uu(1,i,j,k)
!        ee=uu(5,i,j,k)
!        bx=uu(7,i,j,k)
!        by=uu(8,i,j,k)
!        bz=uu(9,i,j,k)
        
        ro=uri(1,i,j,k)
        vx=uri(2,i,j,k)
        vy=uri(3,i,j,k)
        vz=uri(4,i,j,k)
        pp=uri(5,i,j,k)
        bx=uri(7,i,j,k)
        by=uri(8,i,j,k)
        bz=uri(9,i,j,k)
        ex=uri(10,i,j,k)
        ey=uri(11,i,j,k)
        ez=uri(12,i,j,k)
        ch=uri(13,i,j,k)
        ph=uri(14,i,j,k)
        ps=uri(15,i,j,k)
        sg=uri(16,i,j,k)
!          
        vt=vx**2+vy**2+vz**2
        gf=1.0/sqrt(1.0-vt/c0**2)
 
        bt=bx**2+by**2+bz**2
        et=ex**2+ey**2+ez**2
        ev=ex*vx+ey*vy+ez*vz
        
        sx=(ey*bz-ez*by)/c0
        sy=(ez*bx-ex*bz)/c0
        sz=(ex*by-ey*bx)/c0

        eem=0.5*(bt+et)
        dro=gf*ro 
        if(ieos .eq. 0) then
          roh=ro+(gam/(gam-1.0))*pp
        elseif(ieos .eq. 1) then
          roh=(5./2.)*pp+sqrt((9./4.)*pp**2+ro**2)
        elseif(ieos .eq. 3) then
          roh=(12.*pp**2+8.*pp*ro+2.*ro**2)/(3.*pp+2.*ro)
        endif
        dp=(gf**2)*roh
!        dp=ee+pp-eem

        wwj(1,i,j,k)=dro*vy
        wwj(2,i,j,k)=dp*vy*vx   -by*bx-ey*ex
        wwj(3,i,j,k)=dp*vy*vy+pp-by*by-ey*ey+eem
        wwj(4,i,j,k)=dp*vy*vz   -by*bz-ey*ez
        wwj(5,i,j,k)=dp*vy+sy
        wwj(6,i,j,k)=uu(6,i,j,k)*vy
        wwj(7,i,j,k)=ez
        wwj(8,i,j,k)=ph
        wwj(9,i,j,k)=-ex
        wwj(10,i,j,k)=-bz
        wwj(11,i,j,k)=ps
        wwj(12,i,j,k)=bx
        wwj(13,i,j,k)=sg*gf*(ey+(vz*bx-vx*bz)-ev*vy)+ch*vy
        wwj(14,i,j,k)=by
        wwj(15,i,j,k)=ey
         
      enddo
    enddo
  enddo
!
  return
end subroutine calflx3j
!
!---------------------------------------------------------------------@
subroutine calflx3k(uu,wwk,uri,nm0,is1,ie1,js1,je1,ks1,ke1)
!---------------------------------------------------------------------@
  use pram, only : imax, jmax, kmax, nv, ns, gam, c0, ieos  
  implicit none
!
  integer :: i, j, k, is1, ie1, js1, je1, ks1, ke1
  integer :: nm0  
  integer :: merr
!
  real(8) :: uu(nv,is1:ie1,js1:je1,ks1:ke1)
  real(8) :: wwk(nv,is1:ie1,js1:je1,ks1:ke1)
  real(8) :: uri(ns,is1:ie1,js1:je1,ks1:ke1)

  real(8) :: ro, vx, vy, vz, pp, bx, by, bz, ex, ey, ez, ch, ph, ps, sg, &
             dro, ee, vt, bt, et, ev, gf, sx, sy, sz, eem, roh, dp
!
!=====================================================================@
 
  do k=ks1+nm0-1,ke1-nm0
    do j=js1+nm0-1,je1-nm0
      do i=is1+nm0-1,ie1-nm0
!        dro=uu(1,i,j,k)
!        ee=uu(5,i,j,k)
!        bx=uu(7,i,j,k)
!        by=uu(8,i,j,k)
!        bz=uu(9,i,j,k)
        
        ro=uri(1,i,j,k)
        vx=uri(2,i,j,k)
        vy=uri(3,i,j,k)
        vz=uri(4,i,j,k)
        pp=uri(5,i,j,k)
        bx=uri(7,i,j,k)
        by=uri(8,i,j,k)
        bz=uri(9,i,j,k)
        ex=uri(10,i,j,k)
        ey=uri(11,i,j,k)
        ez=uri(12,i,j,k)
        ch=uri(13,i,j,k)
        ph=uri(14,i,j,k)
        ps=uri(15,i,j,k)
        sg=uri(16,i,j,k)
! 
        vt=vx**2+vy**2+vz**2
        gf=1.0/sqrt(1.0-vt/c0**2)
 
        bt=bx**2+by**2+bz**2
        et=ex**2+ey**2+ez**2
        ev=ex*vx+ey*vy+ez*vz

        sx=(ey*bz-ez*by)/c0
        sy=(ez*bx-ex*bz)/c0
        sz=(ex*by-ey*bx)/c0
        
        sx=(ey*bz-ez*by)/c0
        sy=(ez*bx-ex*bz)/c0
        sz=(ex*by-ey*bx)/c0

        eem=0.5*(bt+et)
        dro=gf*ro 
        if(ieos .eq. 0) then
          roh=ro+(gam/(gam-1.0))*pp
        elseif(ieos .eq. 1) then
          roh=(5./2.)*pp+sqrt((9./4.)*pp**2+ro**2)
        elseif(ieos .eq. 3) then
          roh=(12.*pp**2+8.*pp*ro+2.*ro**2)/(3.*pp+2.*ro)
        endif
        dp=(gf**2)*roh
!        dp=ee+pp-eem
         
        wwk(1,i,j,k)=dro*vz
        wwk(2,i,j,k)=dp*vz*vx   -bz*bx-ez*ex
        wwk(3,i,j,k)=dp*vz*vy   -bz*by-ez*ey
        wwk(4,i,j,k)=dp*vz*vz+pp-bz*bz-ez*ez+eem
        wwk(5,i,j,k)=dp*vz+sz
        wwk(6,i,j,k)=uu(6,i,j,k)*vz
        wwk(7,i,j,k)=-ey
        wwk(8,i,j,k)=ex
        wwk(9,i,j,k)=ph
        wwk(10,i,j,k)=by
        wwk(11,i,j,k)=-bx
        wwk(12,i,j,k)=ps
        wwk(13,i,j,k)=sg*gf*(ez+(vx*by-vy*bx)-ev*vz)+ch*vz
        wwk(14,i,j,k)=bz
        wwk(15,i,j,k)=ez
        
      enddo
    enddo
  enddo
!
  return
end subroutine calflx3k 
!
!---------------------------------------------------------------------@
subroutine calwwo(uu,wwo,uri,is1,ie1,js1,je1,ks1,ke1)
!---------------------------------------------------------------------@
  use pram, only : imax, jmax, kmax, nv, ns, gam, c0, ieos
  implicit none

  integer :: i, j, k, is1, ie1, js1, je1, ks1, ke1
  integer :: nm0, merr  
!
  real(8) :: uu(nv,is1:ie1,js1:je1,ks1:ke1)
  real(8) :: wwo(3,nv,is1:ie1,js1:je1,ks1:ke1)
  real(8) :: uri(ns,is1:ie1,js1:je1,ks1:ke1)
!
  real(8) :: ro, vx, vy, vz, pp, bx, by, bz, ex, ey, ez, ch, ph, ps, sg, &
             dro, ee, vt, bt, et, ev, gf, sx, sy, sz, eem, roh, dp
!
!
!=====================================================================@

  do k=ks1,ke1
    do j=js1,je1
      do i=is1,ie1
!        dro=uu(1,i,j,k)
!        ee=uu(5,i,j,k)
!        bx(i,j,k)=uu(7,i,j,k)
!        by(i,j,k)=uu(8,i,j,k)
!        bz(i,j,k)=uu(9,i,j,k)
        
        ro=uri(1,i,j,k)
        vx=uri(2,i,j,k)
        vy=uri(3,i,j,k)
        vz=uri(4,i,j,k)
        pp=uri(5,i,j,k)
        bx=uri(7,i,j,k)
        by=uri(8,i,j,k)
        bz=uri(9,i,j,k)
        ex=uri(10,i,j,k)
        ey=uri(11,i,j,k)
        ez=uri(12,i,j,k)
        ch=uri(13,i,j,k)
        ph=uri(14,i,j,k)
        ps=uri(15,i,j,k)
        sg=uri(16,i,j,k)

        vt=vx**2+vy**2+vz**2
        gf=1.0/sqrt(1.0-vt/c0**2)
        
        bt=bx**2+by**2+bz**2
        et=ex**2+ey**2+ez**2
        ev=ex*vx+ey*vy+ez*vz

        sx=(ey*bz-ez*by)/c0
        sy=(ez*bx-ex*bz)/c0
        sz=(ex*by-ey*bx)/c0

        eem=0.5*(bt+et)
        dro=gf*ro 
        if(ieos .eq. 0) then
          roh=ro+(gam/(gam-1.0))*pp
        elseif(ieos .eq. 1) then
          roh=(5./2.)*pp+sqrt((9./4.)*pp**2+ro**2)
        elseif(ieos .eq. 3) then
          roh=(12.*pp**2+8.*pp*ro+2.*ro**2)/(3.*pp+2.*ro)
        endif
        dp=(gf**2)*roh
!        dp=ee+pp-eem
!
        wwo(1,1,i,j,k)=dro*vx
        wwo(2,1,i,j,k)=dro*vy
        wwo(3,1,i,j,k)=dro*vz
!
        wwo(1,2,i,j,k)=dp*vx*vx+pp-bx*bx-ex*ex+eem
        wwo(1,3,i,j,k)=dp*vx*vy   -bx*by-ex*ey
        wwo(1,4,i,j,k)=dp*vx*vz   -bx*bz-ex*ez
!
        wwo(2,2,i,j,k)=dp*vy*vx   -by*bx-ey*ex
        wwo(2,3,i,j,k)=dp*vy*vy+pp-by*by-ey*ey+eem
        wwo(2,4,i,j,k)=dp*vy*vz   -by*bz-ey*ez
!
        wwo(3,2,i,j,k)=dp*vz*vx   -bz*bx-ez*ex
        wwo(3,3,i,j,k)=dp*vz*vy   -bz*by-ez*ey
        wwo(3,4,i,j,k)=dp*vz*vz+pp-bz*bz-ez*ez+eem
!
        wwo(1,5,i,j,k)=dp*vx+sx
        wwo(2,5,i,j,k)=dp*vy+sy
        wwo(3,5,i,j,k)=dp*vz+sz
!
        wwo(1,6,i,j,k)=uu(6,i,j,k)*vx
        wwo(2,6,i,j,k)=uu(6,i,j,k)*vy
        wwo(3,6,i,j,k)=uu(6,i,j,k)*vz

        wwo(1,7,i,j,k)=ph
        wwo(1,8,i,j,k)=-ez
        wwo(1,9,i,j,k)=ey

        wwo(2,7,i,j,k)=ez
        wwo(2,8,i,j,k)=ph
        wwo(2,9,i,j,k)=-ex

        wwo(3,7,i,j,k)=-ey
        wwo(3,8,i,j,k)=ex
        wwo(3,9,i,j,k)=ph

        wwo(1,10,i,j,k)=ps
        wwo(1,11,i,j,k)=bz
        wwo(1,12,i,j,k)=-by

        wwo(2,10,i,j,k)=-bz
        wwo(2,11,i,j,k)=ps
        wwo(2,12,i,j,k)=bx

        wwo(3,10,i,j,k)=by
        wwo(3,11,i,j,k)=-bx
        wwo(3,12,i,j,k)=ps

        wwo(1,13,i,j,k)=sg*gf*(ex+(vy*bz-vz*by)-ev*vx)+ch*vx
        wwo(2,13,i,j,k)=sg*gf*(ey+(vz*bx-vx*bz)-ev*vy)+ch*vy
        wwo(3,13,i,j,k)=sg*gf*(ez+(vx*by-vy*bx)-ev*vz)+ch*vz

        wwo(1,14,i,j,k)=bx
        wwo(2,14,i,j,k)=by
        wwo(3,14,i,j,k)=bz

        wwo(1,15,i,j,k)=ex
        wwo(2,15,i,j,k)=ey
        wwo(3,15,i,j,k)=ez

      enddo
    enddo
  enddo
!
  return
end subroutine calwwo
