!--------------------------------------------------------------------
subroutine calsg(uri,cuc,eta0,is1,ie1,js1,je1,ks1,ke1)
!--------------------------------------------------------------------
!
! Calculate current-depedent resistivity
!
  use pram, only : imax, jmax, kmax, nv, ns, ires   
  implicit none

  integer :: i, j, k, is1, ie1, js1, je1, ks1, ke1
       
  real(8) :: uri(ns,is1:ie1,js1:je1,ks1:ke1)

  real(8) :: de, v1, v2, v3, b1, b2, b3, e1, e2, e3, ch, sg, vsq, gf, &
             cu1, cu2, cu3, cusq, cuc, eta0, eta1, d0, ev
!      
!=====================================================================
!
! Parameter
!
  d0=1.d0
!
  do k=ks1,ke1
    do j=js1,je1
      do i=is1,ie1

        if(ires .eq. 1) then
!
! current-dependent resistivity
!
          de=uri(1,i,j,k)
          v1=uri(2,i,j,k)
          v2=uri(3,i,j,k)
          v3=uri(4,i,j,k)

          b1=uri(7,i,j,k)
          b2=uri(8,i,j,k)
          b3=uri(9,i,j,k)
          e1=uri(10,i,j,k)
          e2=uri(11,i,j,k)
          e3=uri(12,i,j,k)

          ch=uri(13,i,j,k)
          sg=uri(16,i,j,k)    

          vsq=(v1*v1+v2*v2+v3*v3)
          ev=e1*v1+e2*v2+e3*v3
          gf=1.0/sqrt(1.0-vsq)

          cu1=sg*gf*(e1+(v2*b3-v3*b2)-ev*v1)+ch*v1
          cu2=sg*gf*(e2+(v3*b1-v1*b3)-ev*v2)+ch*v2
          cu3=sg*gf*(e3+(v1*b2-v2*b1)-ev*v3)+ch*v3
          cusq=(cu1**2+cu2**2+cu3**2)-ch**2

          if(cusq .gt. d0**2*cuc**2) then
            eta1=eta0*sqrt(cusq)/(d0*cuc)
            sg=1./eta1 
          endif   

        endif

        uri(16,i,j,k)=sg
      enddo
    enddo
  enddo
      
  return
end subroutine calsg
